'===========================================================================
' To Points
'
' Extracts hits from features And creates vectorpoints With
' the hits THEO's.
'
' The names are created from the source feature Name And a number that
' represents the hit index.
'
' Idea taken from 'to_points.exe' from the Wilcox Script Repository
' which sadly doesn't work As expected.
'
' (c) vpt.se 2010-06-15
' Updated davehocum 20150311
' 20150406 Added To Vector Sample Points, To Generic Sample Points, To Read Point And AndersI Live Gen. Points.
' Added Palor Check Box. Polar will remove the .HIT[ ] from the NOM And MEAS For the Live Gen. Points. 
' Not all Auto Feature will work With the To Vector Sample Points And To Generic Sample Points.
'===========================================================================

Sub Main()
Dim PCDApp, PCDPartPrograms, PCDPartProgram, PCDCommands, PCDCommand
Dim PCDFeatCmd
Dim prbhit
Dim numhits As Integer

Set PCDApp = CreateObject("PCDLRN.Application")
Set PCDPartPrograms = PCDApp.PartPrograms
Set PCDPartProgram = PCDApp.ActivePartProgram
Set PCDCommands = PCDPartProgram.Commands

Dim cmd As Object
Dim Fcntr As Integer
Dim FeatureList$(9999)

Dim hX As Double, hY As Double, hZ As Double, hI As Double, hJ As Double, hK As Double
Dim tX, tY, tZ, mX, mY, mZ As String



'***** Predialog START
Fcntr = 0
' Enumerate commands
For Each cmd In PCDCommands
' Measured (learned) feature
  If cmd.IsMeasuredFeature Then 
    FeatureList(Fcntr) = cmd.ID
    Fcntr = Fcntr + 1
  End If
' Autofeature (flagged As DCC feature)
  If cmd.IsDCCFeature Then
    FeatureList(Fcntr) = cmd.ID
    Fcntr = Fcntr + 1
  End If
' Constructed feature
If cmd.IsConstructedFeature Then
    FeatureList(Fcntr) = cmd.ID
    Fcntr = Fcntr + 1
  End If

Next cmd
'*****

'***** Dialog START
Begin Dialog DIALOG_1 31,48, 242, 201, "Feature to Points v2.0"
  ListBox 78,8,155,187, FeatureList$(), .ListBox
  PushButton 8,8,62,12, "To Vector Points", .VPointsBtn
  PushButton 8,30,62,12, "To Cast Points", .CPointsBtn
  PushButton 8,51,62,12, "To Generic Points", .GPointsBtn
  PushButton 8,72,62,12, "To Vector S Pnts", .VsPointsBtn
  PushButton 8,93,62,12, "To Generic S Pnts", .GsPointsBtn
  PushButton 8,114,62,12, "To Read Point", .RPointsBtn
  PushButton 8,136,62,12, "Live Gen. Points", .LGPointsBtn
  CheckBox 8, 150, 62, 12, "Polar", .PolarCord
  CheckBox 8, 160, 62, 12, "Random error", .GenerateError
  PushButton 8,180,52,12, "Cancel", .CancelBtn
End Dialog

Dim Dlg1 As DIALOG_1
button = Dialog(Dlg1)
' button 0 = Cancel, button 1 = To Vector points, button 2 = To Cast Points, button 3 = To Generic Points, 
' button 4 = To Vector S Pnts, button 5 = To Generic S Pnts, button 6 = To Read Point, button 7 = Live Gen. Points, button 8 = Random Error, 


'*****

'***** Vector Point Generation
Fcntr = 0
If button = 1 Then
  Set PCDCommand = PCDCommands.Item(FeatureList(Dlg1.Listbox)) 
  Set PCDFeatCmd = PCDCommand.FeatureCommand
  numhits = PCDFeatCmd.NumHits
  Set prbhit = CreateObject("PCDLRN.PointData")

For Fcntr = 1 To numhits
  ' Get the probehits - XYZ  
  Set prbhit = PCDFeatCmd.GetHit(Fcntr, FHITDATA_CENTROID, FDATA_THEO, FDATA_PART, AlignID, PLANE_TOP)
  vX = CDbl(prbhit.X)
  vY = CDbl(prbhit.Y)
  vZ = CDbl(prbhit.Z)

   If Dlg1.GenerateError Then
      vX = vX + (Rnd() - Rnd()) / 100.0
      vY = vY + (Rnd() - Rnd()) / 100.0
      vZ = vZ + (Rnd() - Rnd()) / 100.0
    End If
  ' Get the probehits - IJK
  Set prbhit = PCDFeatCmd.GetHit(Fcntr, FHITDATA_VECTOR, FDATA_THEO, FDATA_PART, AlignID, PLANE_TOP)
  vI = CDbl(prbhit.X)
  vJ = CDbl(prbhit.Y)
  vK = CDbl(prbhit.Z)

' Create Vector points feature (COMMAND INFORMATION CODE edit screen) 602
' Create Cast points feature (COMMAND INFORMATION CODE edit screen) 517
' Create Generic points feature (COMMAND INFORMATION CODE edit screen) 597
  Set cmd = PCDCommands.Add(602, True)
  cmd.Marked = True
  'Featurename is "sourcefeaturename-hitnumber" -> PLANE1-1
  retval = cmd.PutText (PCDCommand.ID & "_" & Fcntr, ID, 0)
  'Result = cmd.SetExpression (PCDCommand.ID & "." & "HIT" & "[" & Fcntr & "]" , REF_ID, 0)
  ' Theo's
  retval = cmd.PutText (vX, THEO_X, 0)
  retval = cmd.PutText (vY, THEO_Y, 0)
  retval = cmd.PutText (vZ, THEO_Z, 0)
  retval = cmd.PutText (vI, THEO_I, 0)
  retval = cmd.PutText (vJ, THEO_J, 0)
  retval = cmd.PutText (vK, THEO_K, 0)
  ' Actl's
  'retval = cmd.PutText (vX, MEAS_X, 0)
  'retval = cmd.PutText (vY, MEAS_Y, 0)
  'retval = cmd.PutText (vZ, MEAS_Z, 0)
  'retval = cmd.PutText (vI, MEAS_I, 0)
  'retval = cmd.PutText (vJ, MEAS_J, 0)
  'retval = cmd.PutText (vK, MEAS_K, 0)
  ' Targ's
  retval = cmd.PutText (vX, TARG_X, 0)
  retval = cmd.PutText (vY, TARG_Y, 0)
  retval = cmd.PutText (vZ, TARG_Z, 0)
  retval = cmd.PutText (vI, TARG_I, 0)
  retval = cmd.PutText (vJ, TARG_J, 0)
  retval = cmd.PutText (vK, TARG_K, 0)
If Dlg1.PolarCord Then
     ' Set Coordinate Type  = POLAR
    retval = cmd.SetToggleString (2, COORD_TYPE, 0)
End If

  PCDPartProgram.RefreshPart
  cmd.ReDraw
  

Next
End If

'*****

'***** Cast Point Generation
Fcntr = 0
If button = 2 Then
  Set PCDCommand = PCDCommands.Item(FeatureList(Dlg1.Listbox)) 
  Set PCDFeatCmd = PCDCommand.FeatureCommand
  numhits = PCDFeatCmd.NumHits
  Set prbhit = CreateObject("PCDLRN.PointData")

For Fcntr = 1 To numhits
  ' Get the probehits - XYZ  
  Set prbhit = PCDFeatCmd.GetHit(Fcntr, FHITDATA_CENTROID, FDATA_THEO, FDATA_PART, AlignID, PLANE_TOP)
  cX = CDbl(prbhit.X)
  cY = CDbl(prbhit.Y)
  cZ = CDbl(prbhit.Z)

If Dlg1.GenerateError Then
      vX = vX + (Rnd() - Rnd()) / 100.0
      vY = vY + (Rnd() - Rnd()) / 100.0
      vZ = vZ + (Rnd() - Rnd()) / 100.0
    End If

  ' Get the probehits - IJK
  Set prbhit = PCDFeatCmd.GetHit(Fcntr, FHITDATA_VECTOR, FDATA_THEO, FDATA_PART, AlignID, PLANE_TOP)
  cI = CDbl(prbhit.X)
  cJ = CDbl(prbhit.Y)
  cK = CDbl(prbhit.Z)
' Create Vector points feature (COMMAND INFORMATION CODE edit screen) 602
' Create Cast points feature (COMMAND INFORMATION CODE edit screen) 517
' Create Generic points feature (COMMAND INFORMATION CODE edit screen) 597
  Set cmd = PCDCommands.Add(517, True)

  cmd.Marked = True
  'Featurename is "sourcefeaturename-hitnumber" -> PLANE1-1
  retval = cmd.PutText (PCDCommand.ID & "_C" & Fcntr, ID, 0)
  Result = cmd.SetExpression (PCDCommand.ID & "." & "HIT" & "[" & Fcntr & "]" , REF_ID, 0)
  ' Theo's
  retval = cmd.PutText (cX, THEO_X, 0)
  retval = cmd.PutText (cY, THEO_Y, 0)
  retval = cmd.PutText (cZ, THEO_Z, 0)
  retval = cmd.PutText (cI, THEO_I, 0)
  retval = cmd.PutText (cJ, THEO_J, 0)
  retval = cmd.PutText (cK, THEO_K, 0)
  ' Actl's
  retval = cmd.PutText (cX, MEAS_X, 0)
  retval = cmd.PutText (cY, MEAS_Y, 0)
  retval = cmd.PutText (cZ, MEAS_Z, 0)
  retval = cmd.PutText (cI, MEAS_I, 0)
  retval = cmd.PutText (cJ, MEAS_J, 0)
  retval = cmd.PutText (cK, MEAS_K, 0)
  ' Targ's
  retval = cmd.PutText (cX, TARG_X, 0)
  retval = cmd.PutText (cY, TARG_Y, 0)
  retval = cmd.PutText (cZ, TARG_Z, 0)
  retval = cmd.PutText (cI, TARG_I, 0)
  retval = cmd.PutText (cJ, TARG_J, 0)
  retval = cmd.PutText (cK, TARG_K, 0)
If Dlg1.PolarCord Then
     ' Set Coordinate Type  = POLAR
    retval = cmd.SetToggleString (2, COORD_TYPE, 0)
 ' Set User Specified Theos  = NO
    retval = cmd.SetToggleString (1, USER_DEFINED_THEOS, 0)

End If

  PCDPartProgram.RefreshPart
  cmd.ReDraw
  ' Set User Specified Theos  = YES
    retval = cmd.SetToggleString (2, USER_DEFINED_THEOS, 0)

Next
End If

'*****

'***** Generic Point Generation
Fcntr = 0
If button = 3 Then
  Set PCDCommand = PCDCommands.Item(FeatureList(Dlg1.Listbox)) 
  Set PCDFeatCmd = PCDCommand.FeatureCommand
  numhits = PCDFeatCmd.NumHits
  Set prbhit = CreateObject("PCDLRN.PointData")

For Fcntr = 1 To numhits
  ' Get the probehits - XYZ  
  Set prbhit = PCDFeatCmd.GetHit(Fcntr, FHITDATA_CENTROID, FDATA_THEO, FDATA_PART, AlignID, PLANE_TOP)
  gX = CDbl(prbhit.X)
  gY = CDbl(prbhit.Y)
  gZ = CDbl(prbhit.Z)

If Dlg1.GenerateError Then
      vX = vX + (Rnd() - Rnd()) / 100.0
      vY = vY + (Rnd() - Rnd()) / 100.0
      vZ = vZ + (Rnd() - Rnd()) / 100.0
    End If

  ' Get the probehits - IJK
  Set prbhit = PCDFeatCmd.GetHit(Fcntr, FHITDATA_VECTOR, FDATA_THEO, FDATA_PART, AlignID, PLANE_TOP)
  gI = CDbl(prbhit.X)
  gJ = CDbl(prbhit.Y)
  gK = CDbl(prbhit.Z)
' Create Vector points feature (COMMAND INFORMATION CODE edit screen) 602
' Create Cast points feature (COMMAND INFORMATION CODE edit screen) 517
' Create Generic points feature (COMMAND INFORMATION CODE edit screen) 597
  Set cmd = PCDCommands.Add(597, True)
  cmd.Marked = True
  'Featurename is "sourcefeaturename-hitnumber" -> PLANE1-1
  retval = cmd.PutText (PCDCommand.ID & "_F" & Fcntr, ID, 0)
  'Result = cmd.SetExpression (PCDCommand.ID & "." & "HIT" & "[" & Fcntr & "]" , REF_ID, 0)
  ' Theo's
  retval = cmd.PutText (gX, THEO_X, 0)
  retval = cmd.PutText (gY, THEO_Y, 0)
  retval = cmd.PutText (gZ, THEO_Z, 0)
  retval = cmd.PutText (gI, THEO_I, 0)
  retval = cmd.PutText (gJ, THEO_J, 0)
  retval = cmd.PutText (gK, THEO_K, 0)
  ' Actl's
  retval = cmd.PutText (gX, MEAS_X, 0)
  retval = cmd.PutText (gY, MEAS_Y, 0)
  retval = cmd.PutText (gZ, MEAS_Z, 0)
  retval = cmd.PutText (gI, MEAS_I, 0)
  retval = cmd.PutText (gJ, MEAS_J, 0)
  retval = cmd.PutText (gK, MEAS_K, 0)
  ' Targ's
  retval = cmd.PutText (gX, TARG_X, 0)
  retval = cmd.PutText (gY, TARG_Y, 0)
  retval = cmd.PutText (gZ, TARG_Z, 0)
  retval = cmd.PutText (gI, TARG_I, 0)
  retval = cmd.PutText (gJ, TARG_J, 0)
  retval = cmd.PutText (gK, TARG_K, 0)
If Dlg1.PolarCord Then
     ' Set Coordinate Type  = POLAR
    retval = cmd.SetToggleString (2, COORD_TYPE, 0)
End If

  PCDPartProgram.RefreshPart
  cmd.ReDraw
  

Next
End If

'***** Vector Point Generation Sample Hits
Fcntr = 0
If button = 4 Then
  Set PCDCommand = PCDCommands.Item(FeatureList(Dlg1.Listbox)) 
  Set PCDFeatCmd = PCDCommand.FeatureCommand
  numhits = PCDFeatCmd.PermHits
  Set prbhit = CreateObject("PCDLRN.PointData")

For Fcntr = 1 To numhits
  ' Get the probehits - XYZ  
  Set prbhit = PCDFeatCmd.GetSampleHit(Fcntr, FHITDATA_CENTROID, FDATA_THEO, FDATA_PART, AlignID, PLANE_TOP)
  vX = CDbl(prbhit.X)
  vY = CDbl(prbhit.Y)
  vZ = CDbl(prbhit.Z)

If Dlg1.GenerateError Then
      vX = vX + (Rnd() - Rnd()) / 100.0
      vY = vY + (Rnd() - Rnd()) / 100.0
      vZ = vZ + (Rnd() - Rnd()) / 100.0
    End If

  ' Get the probehits - IJK
  Set prbhit = PCDFeatCmd.GetSampleHit(Fcntr, FHITDATA_VECTOR, FDATA_THEO, FDATA_PART, AlignID, PLANE_TOP)
  vI = CDbl(prbhit.X)
  vJ = CDbl(prbhit.Y)
  vK = CDbl(prbhit.Z)

' Create Vector points feature (COMMAND INFORMATION CODE edit screen) 602
' Create Cast points feature (COMMAND INFORMATION CODE edit screen) 517
' Create Generic points feature (COMMAND INFORMATION CODE edit screen) 597
  Set cmd = PCDCommands.Add(602, True)
  cmd.Marked = True
  'Featurename is "sourcefeaturename-hitnumber" -> PLANE1-1
  retval = cmd.PutText (PCDCommand.ID & "_S" & Fcntr, ID, 0)
  'Result = cmd.SetExpression (PCDCommand.ID & "." & "HIT" & "[" & Fcntr & "]" , REF_ID, 0)
  ' Theo's
  retval = cmd.PutText (vX, THEO_X, 0)
  retval = cmd.PutText (vY, THEO_Y, 0)
  retval = cmd.PutText (vZ, THEO_Z, 0)
  retval = cmd.PutText (vI, THEO_I, 0)
  retval = cmd.PutText (vJ, THEO_J, 0)
  retval = cmd.PutText (vK, THEO_K, 0)
  ' Actl's
  retval = cmd.PutText (vX, MEAS_X, 0)
  retval = cmd.PutText (vY, MEAS_Y, 0)
  retval = cmd.PutText (vZ, MEAS_Z, 0)
  retval = cmd.PutText (vI, MEAS_I, 0)
  retval = cmd.PutText (vJ, MEAS_J, 0)
  retval = cmd.PutText (vK, MEAS_K, 0)
  ' Targ's
  retval = cmd.PutText (vX, TARG_X, 0)
  retval = cmd.PutText (vY, TARG_Y, 0)
  retval = cmd.PutText (vZ, TARG_Z, 0)
  retval = cmd.PutText (vI, TARG_I, 0)
  retval = cmd.PutText (vJ, TARG_J, 0)
  retval = cmd.PutText (vK, TARG_K, 0)
If Dlg1.PolarCord Then
     ' Set Coordinate Type  = POLAR
    retval = cmd.SetToggleString (2, COORD_TYPE, 0)
End If

  PCDPartProgram.RefreshPart
  cmd.ReDraw
  

Next
End If

'***** Generic Point Generation Sample Hits
Fcntr = 0
If button = 5 Then
  Set PCDCommand = PCDCommands.Item(FeatureList(Dlg1.Listbox)) 
  Set PCDFeatCmd = PCDCommand.FeatureCommand
  numhits = PCDFeatCmd.PermHits
  Set prbhit = CreateObject("PCDLRN.PointData")

For Fcntr = 1 To numhits
  ' Get the probehits - XYZ  
  Set prbhit = PCDFeatCmd.GetSampleHit(Fcntr, FHITDATA_CENTROID, FDATA_THEO, FDATA_PART, AlignID, PLANE_TOP)
  gX = CDbl(prbhit.X)
  gY = CDbl(prbhit.Y)
  gZ = CDbl(prbhit.Z)

If Dlg1.GenerateError Then
      vX = vX + (Rnd() - Rnd()) / 100.0
      vY = vY + (Rnd() - Rnd()) / 100.0
      vZ = vZ + (Rnd() - Rnd()) / 100.0
    End If

  ' Get the probehits - IJK
  Set prbhit = PCDFeatCmd.GetSampleHit(Fcntr, FHITDATA_VECTOR, FDATA_THEO, FDATA_PART, AlignID, PLANE_TOP)
  gI = CDbl(prbhit.X)
  gJ = CDbl(prbhit.Y)
  gK = CDbl(prbhit.Z)

 ' Create Vector points feature (COMMAND INFORMATION CODE edit screen) 602
' Create Cast points feature (COMMAND INFORMATION CODE edit screen) 517
' Create Generic points feature (COMMAND INFORMATION CODE edit screen) 597
  Set cmd = PCDCommands.Add(597, True)
  cmd.Marked = True
  'Featurename is "sourcefeaturename-hitnumber" -> PLANE1-1
  retval = cmd.PutText (PCDCommand.ID & "_SG" & Fcntr, ID, 0)
  'Result = cmd.SetExpression (PCDCommand.ID & "." & "HIT" & "[" & Fcntr & "]" , REF_ID, 0)
  ' Theo's
  retval = cmd.PutText (gX, THEO_X, 0)
  retval = cmd.PutText (gY, THEO_Y, 0)
  retval = cmd.PutText (gZ, THEO_Z, 0)
  retval = cmd.PutText (gI, THEO_I, 0)
  retval = cmd.PutText (gJ, THEO_J, 0)
  retval = cmd.PutText (gK, THEO_K, 0)
  ' Actl's
  retval = cmd.PutText (gX, MEAS_X, 0)
  retval = cmd.PutText (gY, MEAS_Y, 0)
  retval = cmd.PutText (gZ, MEAS_Z, 0)
  retval = cmd.PutText (gI, MEAS_I, 0)
  retval = cmd.PutText (gJ, MEAS_J, 0)
  retval = cmd.PutText (gK, MEAS_K, 0)
  ' Targ's
  retval = cmd.PutText (gX, TARG_X, 0)
  retval = cmd.PutText (gY, TARG_Y, 0)
  retval = cmd.PutText (gZ, TARG_Z, 0)
  retval = cmd.PutText (gI, TARG_I, 0)
  retval = cmd.PutText (gJ, TARG_J, 0)
  retval = cmd.PutText (gK, TARG_K, 0)
If Dlg1.PolarCord Then
     ' Set Coordinate Type  = POLAR
    retval = cmd.SetToggleString (2, COORD_TYPE, 0)
End If

  PCDPartProgram.RefreshPart
  cmd.ReDraw
  

Next
End If

'*****

'***** Read Point Generation
Fcntr = 0
If button = 6 Then
  Set PCDCommand = PCDCommands.Item(FeatureList(Dlg1.Listbox)) 
  Set PCDFeatCmd = PCDCommand.FeatureCommand
  numhits = 1
  
For Fcntr = 1 To numhits
  
  tX = PCDCommand.GetText (THEO_X, 0)
  tY = PCDCommand.GetText (THEO_Y, 0)
  tZ = PCDCommand.GetText (THEO_Z, 0)
  
  mX = PCDCommand.GetText (MEAS_X, 0)
  mY = PCDCommand.GetText (MEAS_Y, 0)
  mZ = PCDCommand.GetText (MEAS_Z, 0)

' Create Vector points feature (COMMAND INFORMATION CODE edit screen) 602
' Create Cast points feature (COMMAND INFORMATION CODE edit screen) 517
' Create Generic points feature (COMMAND INFORMATION CODE edit screen) 597
' Create Read point feature (COMMAND INFORMATION CODE edit screen) 192
  Set cmd = PCDCommands.Add(192, True)
  cmd.Marked = True
  'Featurename is "sourcefeaturename-hitnumber" -> PLANE1-1
  retval = cmd.PutText (PCDCommand.ID & "_R" & Fcntr, ID, 0)
  'Result = cmd.SetExpression (PCDCommand.ID & "." & "HIT" & "[" & Fcntr & "]" , REF_ID, 0)
  ' Theo's
  retval = cmd.PutText (tX, THEO_X, 0)
  retval = cmd.PutText (tY, THEO_Y, 0)
  retval = cmd.PutText (tZ, THEO_Z, 0)
  retval = cmd.PutText (tI, THEO_I, 0)
  retval = cmd.PutText (tJ, THEO_J, 0)
  retval = cmd.PutText (tK, THEO_K, 0)
  ' Actl's
  retval = cmd.PutText (tX, MEAS_X, 0)
  retval = cmd.PutText (tY, MEAS_Y, 0)
  retval = cmd.PutText (tZ, MEAS_Z, 0)
  retval = cmd.PutText (tI, ACTL_I, 0)
  retval = cmd.PutText (tJ, ACTL_J, 0)
  retval = cmd.PutText (tK, ACTL_K, 0)
  ' Targ's
  retval = cmd.PutText (tX, TARG_X, 0)
  retval = cmd.PutText (tY, TARG_Y, 0)
  retval = cmd.PutText (tZ, TARG_Z, 0)
  retval = cmd.PutText (tI, TARG_I, 0)
  retval = cmd.PutText (tJ, TARG_J, 0)
  retval = cmd.PutText (tK, TARG_K, 0)
If Dlg1.PolarCord Then
     ' Set Coordinate Type  = POLAR
    retval = cmd.SetToggleString (2, COORD_TYPE, 0)
End If

  PCDPartProgram.RefreshPart
  cmd.ReDraw

  Next
End If

'*****

'***** Live Generic Point Generation
Fcntr = 0
If button = 7 Then
  Set PCDCommand = PCDCommands.Item(FeatureList(Dlg1.Listbox)) 
  Set PCDFeatCmd = PCDCommand.FeatureCommand
  numhits = PCDFeatCmd.NumHits
  Set prbhit = CreateObject("PCDLRN.PointData")

For Fcntr = 1 To numhits
  ' Get the probehits - XYZ  
  Set prbhit = PCDFeatCmd.GetHit(Fcntr, FHITDATA_CENTROID, FDATA_THEO, FDATA_PART, AlignID, PLANE_TOP)
  gX = CDbl(prbhit.X)
  gY = CDbl(prbhit.Y)
  gZ = CDbl(prbhit.Z)

If Dlg1.GenerateError Then
      vX = vX + (Rnd() - Rnd()) / 100.0
      vY = vY + (Rnd() - Rnd()) / 100.0
      vZ = vZ + (Rnd() - Rnd()) / 100.0
    End If

  ' Get the probehits - IJK
  Set prbhit = PCDFeatCmd.GetHit(Fcntr, FHITDATA_VECTOR, FDATA_THEO, FDATA_PART, AlignID, PLANE_TOP)
  gI = CDbl(prbhit.X)
  gJ = CDbl(prbhit.Y)
  gK = CDbl(prbhit.Z)
' Create Vector points feature (COMMAND INFORMATION CODE edit screen) 602
' Create Cast points feature (COMMAND INFORMATION CODE edit screen) 517
' Create Generic points feature (COMMAND INFORMATION CODE edit screen) 597
  Set cmd = PCDCommands.Add(597, True)
  cmd.Marked = True
  'Featurename is "sourcefeaturename-hitnumber" -> PLANE1-1
  retval = cmd.PutText (PCDCommand.ID & "_F" & Fcntr, ID, 0)
  'Result = cmd.SetExpression (PCDCommand.ID & "." & "HIT" & "[" & Fcntr & "]" , REF_ID, 0)
pName = PCDCommand.ID & "." & "HIT" & "[" & Fcntr & "]."
  ' Theo's
  retval = cmd.SetExpression (pName & "TX", THEO_X, 0)
      retval = cmd.SetExpression (pName & "TY", THEO_Y, 0)
      retval = cmd.SetExpression (pName & "TZ", THEO_Z, 0)
      retval = cmd.SetExpression (pName & "TI", THEO_I, 0)
      retval = cmd.SetExpression (pName & "TJ", THEO_J, 0)
      retval = cmd.SetExpression (pName & "TK", THEO_K, 0)
      ' Actl's
      retval = cmd.SetExpression (pName & "X", MEAS_X, 0)
      retval = cmd.SetExpression (pName & "Y", MEAS_Y, 0)
      retval = cmd.SetExpression (pName & "Z", MEAS_Z, 0)
      retval = cmd.SetExpression (pName & "I", MEAS_I, 0)
      retval = cmd.SetExpression (pName & "J", MEAS_J, 0)
      retval = cmd.SetExpression (pName & "K", MEAS_K, 0)
If Dlg1.PolarCord Then
     ' Set Coordinate Type  = POLAR
    retval = cmd.SetToggleString (2, COORD_TYPE, 0)
End If

  PCDPartProgram.RefreshPart
  cmd.ReDraw
  

Next
End If





'*****
'***** Cleanup
Set PCDApp = Nothing
Set PCDPartPrograms = Nothing
Set PCDPartProgram = Nothing
Set PCDCommands = Nothing
Set prbhit = Nothing
'*****

End Sub
